# coding: utf-8

#
# Copyright 2010-2014 Ning, Inc.
# Copyright 2014-2020 Groupon, Inc
# Copyright 2020-2021 Equinix, Inc
# Copyright 2014-2021 The Billing Project, LLC
#
# The Billing Project, LLC licenses this file to you under the Apache License, version 2.0
# (the "License"); you may not use this file except in compliance with the
# License.  You may obtain a copy of the License at:
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
# License for the specific language governing permissions and limitations
# under the License.
#

"""
    Kill Bill

    Kill Bill is an open-source billing and payments platform  # noqa: E501

    OpenAPI spec version: 0.24.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six



class AccountTimeline(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account': 'Account',
        'bundles': 'List[Bundle]',
        'invoices': 'List[Invoice]',
        'payments': 'List[InvoicePayment]'
    }

    attribute_map = {
        'account': 'account',
        'bundles': 'bundles',
        'invoices': 'invoices',
        'payments': 'payments'
    }

    def __init__(self, account=None, bundles=None, invoices=None, payments=None):  # noqa: E501
        """AccountTimeline - a model defined in Swagger"""  # noqa: E501

        self._account = None
        self._bundles = None
        self._invoices = None
        self._payments = None
        self.discriminator = None

        if account is not None:
            self.account = account
        if bundles is not None:
            self.bundles = bundles
        if invoices is not None:
            self.invoices = invoices
        if payments is not None:
            self.payments = payments

    @property
    def account(self):
        """Gets the account of this AccountTimeline.  # noqa: E501


        :return: The account of this AccountTimeline.  # noqa: E501
        :rtype: Account
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this AccountTimeline.


        :param account: The account of this AccountTimeline.  # noqa: E501
        :type: Account
        """


        self._account = account

    @property
    def bundles(self):
        """Gets the bundles of this AccountTimeline.  # noqa: E501


        :return: The bundles of this AccountTimeline.  # noqa: E501
        :rtype: List[Bundle]
        """
        return self._bundles

    @bundles.setter
    def bundles(self, bundles):
        """Sets the bundles of this AccountTimeline.


        :param bundles: The bundles of this AccountTimeline.  # noqa: E501
        :type: List[Bundle]
        """


        self._bundles = bundles

    @property
    def invoices(self):
        """Gets the invoices of this AccountTimeline.  # noqa: E501


        :return: The invoices of this AccountTimeline.  # noqa: E501
        :rtype: List[Invoice]
        """
        return self._invoices

    @invoices.setter
    def invoices(self, invoices):
        """Sets the invoices of this AccountTimeline.


        :param invoices: The invoices of this AccountTimeline.  # noqa: E501
        :type: List[Invoice]
        """


        self._invoices = invoices

    @property
    def payments(self):
        """Gets the payments of this AccountTimeline.  # noqa: E501


        :return: The payments of this AccountTimeline.  # noqa: E501
        :rtype: List[InvoicePayment]
        """
        return self._payments

    @payments.setter
    def payments(self, payments):
        """Sets the payments of this AccountTimeline.


        :param payments: The payments of this AccountTimeline.  # noqa: E501
        :type: List[InvoicePayment]
        """


        self._payments = payments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountTimeline):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
