# coding: utf-8

#
# Copyright 2010-2014 Ning, Inc.
# Copyright 2014-2020 Groupon, Inc
# Copyright 2020-2021 Equinix, Inc
# Copyright 2014-2021 The Billing Project, LLC
#
# The Billing Project, LLC licenses this file to you under the Apache License, version 2.0
# (the "License"); you may not use this file except in compliance with the
# License.  You may obtain a copy of the License at:
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
# License for the specific language governing permissions and limitations
# under the License.
#

"""
    Kill Bill

    Kill Bill is an open-source billing and payments platform  # noqa: E501

    OpenAPI spec version: 0.24.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six



class TenantKeyValue(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'key': 'Str',
        'values': 'List[Str]',
        'audit_logs': 'List[AuditLog]'
    }

    attribute_map = {
        'key': 'key',
        'values': 'values',
        'audit_logs': 'auditLogs'
    }

    def __init__(self, key=None, values=None, audit_logs=None):  # noqa: E501
        """TenantKeyValue - a model defined in Swagger"""  # noqa: E501

        self._key = None
        self._values = None
        self._audit_logs = None
        self.discriminator = None

        if key is not None:
            self.key = key
        if values is not None:
            self.values = values
        if audit_logs is not None:
            self.audit_logs = audit_logs

    @property
    def key(self):
        """Gets the key of this TenantKeyValue.  # noqa: E501


        :return: The key of this TenantKeyValue.  # noqa: E501
        :rtype: Str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this TenantKeyValue.


        :param key: The key of this TenantKeyValue.  # noqa: E501
        :type: Str
        """


        self._key = key

    @property
    def values(self):
        """Gets the values of this TenantKeyValue.  # noqa: E501


        :return: The values of this TenantKeyValue.  # noqa: E501
        :rtype: List[Str]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this TenantKeyValue.


        :param values: The values of this TenantKeyValue.  # noqa: E501
        :type: List[Str]
        """


        self._values = values

    @property
    def audit_logs(self):
        """Gets the audit_logs of this TenantKeyValue.  # noqa: E501


        :return: The audit_logs of this TenantKeyValue.  # noqa: E501
        :rtype: List[AuditLog]
        """
        return self._audit_logs

    @audit_logs.setter
    def audit_logs(self, audit_logs):
        """Sets the audit_logs of this TenantKeyValue.


        :param audit_logs: The audit_logs of this TenantKeyValue.  # noqa: E501
        :type: List[AuditLog]
        """


        self._audit_logs = audit_logs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TenantKeyValue):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
